class Is {
    static callToString(arg) {
        return Object.prototype.toString.call(arg)
    }

    static String(arg) {
        return Is.callToString(arg) === '[object String]';
    }

    static is(arg, type){
        if (!Is.String(type)) throw new Error('"type" must be a String');
        return Is.callToString(arg) === `[object ${type}]`;
    }

    static Array(arg){
        return Is.is(arg, 'Array');
    }

    static Null(arg){
        return Is.is(arg, 'Null');
    }

    static Number(arg) {
        return Is.is(arg, 'Number');
    }

    static Object(arg){
        return Is.is(arg, 'Object');
    }

    static Undefined(arg){
        return Is.is(arg, 'Undefined');
    }

    static Boolean(arg){
        return Is.is(arg, 'Boolean');
    }

    static Function(arg) {
        return Is.is(arg, 'Function');
    }
}

module.exports = Is;